/*!
 * Ghostery for Firefox
 * http://www.ghostery.com/
 *
 * Copyright 2013 EVIDON, Inc. All rights reserved.
 * See ghostery_eula.txt for license.
 */

// TODO slim down as much as possible
(function () {

	var ALERT_ID = id(),
		ALERT_TIMER,
		CSS_INJECTED = false,
		// all_frames is false in the page-mod
		//IS_FRAME = (win.top != win),
		TRANSLATIONS = {},
		UPGRADE_ALERT_SHOWN = false,
		doc = document,
		win = window,
		sendMessage = function (name, msg) {
			self.port.emit(name, msg);
		};

	function id() {
		var s = '';
		while (s.length < 32) {
			s += Math.random().toString(36).replace(/[^A-Za-z]/g, '');
		}
		return s;
	}

	function createEl(type) {
		return doc.createElement(type);
	}

	function br() {
		return createEl('br');
	}

	// arguments: parentElement, *childElements
	function appendChild(parent) {
		for (var i = 1; i < arguments.length; i++) {
			parent.appendChild(arguments[i]);
		}
	}

	function injectScript(src_url, source) {
		var script = createEl('script'),
			parent = win.top.document.documentElement;

		if (src_url) {
			script.src = src_url;
		} else {
			script.textContent = source;
		}

		parent.insertBefore(script, parent.firstChild);
	}

	function injectCSS() {
		var style = createEl('style'),
			imp = ' !important;';

		style.innerHTML =
			'#' + ALERT_ID + '{' +
				'border:solid 2px #fff' + imp +
				'color:#fff' + imp +
				'display:block' + imp +
				'height:auto' + imp +
				'margin:0' + imp +
				'opacity:0.9' + imp +
				'padding:7px 10px' + imp +
				'position:fixed' + imp +
				'visibility:visible' + imp +
				'width:auto' + imp +
				'z-index:2147483647' + imp +
				'-moz-border-radius:5px' + imp +
				'border-radius:5px' + imp +
				'-moz-box-shadow:0px 0px 20px #000' + imp +
				'box-shadow:0px 0px 20px #000' + imp +
			'}' +

			'.' + ALERT_ID + '-blocked{' +
				'color:#777' + imp +
				'display:inline' + imp +
				'text-decoration:line-through' + imp +
			'}' +

			'#' + ALERT_ID + ' br{display:block' + imp + '}' +

			'#' + ALERT_ID + ' span{background:transparent' + imp + '}' +

			'#' + ALERT_ID + ' div{' +
				'border:0' + imp +
				'margin:0' + imp +
				'padding:0' + imp +
				'width:auto' + imp +
				'letter-spacing:normal' + imp +
				'font:13px Arial,Helvetica' + imp +
				'text-align:left' + imp +
				'text-shadow:none' + imp +
				'text-transform:none' + imp +
				'word-spacing:normal' + imp +
			'}' +

			'#' + ALERT_ID + ' a{' +
				'font-weight:normal' + imp +
				'background:none' + imp +
				'text-decoration:underline' + imp +
				'color:#fff' + imp +
			'}' +

			'@media print{#' + ALERT_ID + '{display:none' + imp + '}}';

		appendChild(doc.getElementsByTagName('head')[0], style);
	}

	function removeAlert() {
		var el = doc.getElementById(ALERT_ID);
		if (el) {
			el.parentNode.removeChild(el);
		}
		clearTimeout(ALERT_TIMER);
	}

	function createAlertLink(href, text) {
		var link = createEl('a');
		link.style.color = '#fff';
		link.style.textDecoration = 'underline';
		link.style.border = 'none';
		link.href = href || '#';
		if (href) {
			link.target = '_blank';
		}
		appendChild(link, doc.createTextNode(text));
		return link;
	}

	function span(text, class_name) {
		var s = createEl('span');
		if (class_name) {
			s.className = class_name;
		}
		appendChild(s, doc.createTextNode(text));
		return s;
	}

	function createAlert(type, alert_cfg) {
		var alert_div = createEl('div');

		alert_div.id = ALERT_ID;

		alert_div.style.setProperty(
			(alert_cfg && alert_cfg.pos_x == 'left' ? 'left' : 'right'),
			'20px',
			'important');
		alert_div.style.setProperty(
			(alert_cfg && alert_cfg.pos_y == 'bottom' ? 'bottom' : 'top'),
			'15px',
			'important');
		alert_div.style.setProperty(
			'background',
			(type == 'showBugs' ? '#330033' : '#777'),
			'important');

		if (doc.getElementsByTagName('body')[0]) {
			appendChild(doc.body, alert_div);
		} else {
			appendChild(doc.getElementsByTagName('html')[0], alert_div);
		}

		if (type == 'showBugs') {
			alert_div.style.cursor = 'pointer';
			alert_div.addEventListener('click', function (e) {
				removeAlert();
				e.preventDefault();
			});
		}

		return alert_div;
	}

	function showAlert(type, bugs, alert_cfg) {
		// only tear down the frame for upgrade notifications/walkthrough reminders
		if (type != 'showBugs') {
			removeAlert();
		}

		var alert_div,
			alert_contents = createEl('div'),
			link;

		alert_contents.style.setProperty(
			'background',
			(type == 'showBugs' ? '#330033' : '#777'),
			'important');

		if (type == 'showBugs') {
			for (var i = 0; i < bugs.length; i++) {
				appendChild(alert_contents, span(
					bugs[i].name,
					(bugs[i].blocked ? ALERT_ID + '-blocked' : '')
				), br());
			}

		} else {
			if (type != 'showUpdateAlert') {
				appendChild(alert_contents, createAlertLink(
					'http://purplebox.ghostery.com/?cat=83',
					TRANSLATIONS.notification_upgrade
				));
			}

			if (type == 'showWalkthroughAlert' || type == 'showUpdateAlert') {
				if (type == 'showUpdateAlert') {
					appendChild(alert_contents, span(TRANSLATIONS.notification_update));
					link = createAlertLink('', TRANSLATIONS.notification_update_link);

				} else {
					appendChild(alert_contents,
						br(),
						br(),
						span(TRANSLATIONS.notification_reminder1),
						br(),
						span(TRANSLATIONS.notification_reminder2)
					);
					link = createAlertLink('', TRANSLATIONS.notification_reminder_link);
				}

				link.addEventListener('click', function (e) {
					sendMessage(type == 'showUpdateAlert' ? 'showNewTrackers' : 'openWalkthrough');
					e.preventDefault();
				});
				appendChild(alert_contents, br(), br(), link);
			}

			link = createAlertLink(false, TRANSLATIONS.dismiss);
			link.addEventListener('click', function (e) {
				removeAlert();
				e.preventDefault();
			});
			appendChild(alert_contents, br(), br(), link);
		}

		alert_div = doc.getElementById(ALERT_ID);

		if (!alert_div) {
			alert_div = createAlert(type, alert_cfg);
		}

		alert_div.innerHTML = '';
		appendChild(alert_div, alert_contents);

		// restart the close alert bubble timer
		clearTimeout(ALERT_TIMER);
		if (alert_cfg && alert_cfg.timeout) {
			ALERT_TIMER = setTimeout(removeAlert, alert_cfg.timeout * 1000);
		}
	}

	self.port.on('show', function (msg) {
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		if (!UPGRADE_ALERT_SHOWN) {
			showAlert('showBugs', msg.bugs, msg.alert_cfg);
		}
	});
	self.port.on('showUpgradeAlert', function (msg) {
		TRANSLATIONS = msg.translations;
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		showAlert('showUpgradeAlert');
		UPGRADE_ALERT_SHOWN = true;
	});
	self.port.on('showWalkthroughAlert', function (msg) {
		TRANSLATIONS = msg.translations;
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		showAlert('showWalkthroughAlert');
		UPGRADE_ALERT_SHOWN = true;
	});
	self.port.on('showUpdateAlert', function (msg) {
		TRANSLATIONS = msg.translations;
		if (!CSS_INJECTED) {
			CSS_INJECTED = true;
			injectCSS();
		}
		showAlert('showUpdateAlert');
		UPGRADE_ALERT_SHOWN = true;
	});

	sendMessage('pageInjected');

}());
