/*!
 * Ghostery for Firefox
 * http://www.ghostery.com/
 *
 * Copyright 2013 EVIDON, Inc. All rights reserved.
 * See ghostery_eula.txt for license.
 */

var parseUri = require('vendor/parseuri').parseUri,
	tabInfo = {},
	lastLoadedTabUrl = ''; // is used for cookie whitelisting

function last() {
	return lastLoadedTabUrl;
}

function clear(tab_id) {
	delete tabInfo[tab_id];
}

function create(tab_id, tab_url) {
	lastLoadedTabUrl = tab_url;
	var parsed = parseUri(tab_url);

	tabInfo[tab_id] = {
		url: tab_url,
		host: parsed.host,
		path: parsed.path,
		hash: parsed.anchor,
		// sids: [], // TODO
		DOMLoaded: false,
		pageLoaded: false,
		needsReload: 0,
		worker: false
	};
}

function get(tab_id) {
	return tabInfo[tab_id];
}

exports.create = create;
exports.get = get;
exports.getAll = function () {
	return tabInfo;
};
exports.clear = clear;
exports.lastLoadedTabUrl = last;
